//********************************************************************
//*** Types/arg_traits.hh
//*** Copyright (c) 2003-2005 by Markus Winand <mws@fatalmind.com>
//*** $Id: arg_traits.hh,v 1.2 2005-01-06 16:28:08 mws Exp $
//********************************************************************

#ifndef TYPES_ARG_TRAITS_HH
#define TYPES_ARG_TRAITS_HH

#include <string>

namespace fatalmind {

template<typename T>
class arg_traits {
	public:
		typedef const T& const_param;
};

// TODO: built in types should be specialized
template<> class arg_traits<int> {
	public: typedef const int const_param;
};

template<> class arg_traits<void*> {
	public: typedef const void* const_param;
};

} // namespace fatalmind

#endif
