//********************************************************************
//*** Thread/Thread.t.cc
//*** Copyright (c) 2003-2009 by Markus Winand <mws@fatalmind.com>
//*** $Id: Thread.t.cc,v 1.13 2009-03-02 14:16:47 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#include "Thread/Thread.hh"

#include "t/main.hh"

using namespace fatalmind;

class MyTask: public Task {
	public:
		MyTask() {};
		virtual ~MyTask() {};
	
		virtual void run() {
		}
};

void TEST_Thread_construct() {
	class Thread t;
}

void TEST_Thread_start_join() {
	class Thread t;
	std::auto_ptr<Task> tsk(new MyTask());
	t.start(tsk);
	t.join();
}
